? route-bzero-fix-20031126.patch
Index: in_pcb.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/in_pcb.c,v
retrieving revision 1.134
diff -u -p -r1.134 in_pcb.c
--- in_pcb.c	26 Nov 2003 01:40:43 -0000	1.134
+++ in_pcb.c	26 Nov 2003 15:47:04 -0000
@@ -581,7 +581,7 @@ in_pcbconnect_setup(inp, nam, laddrp, lp
 	if (laddr.s_addr == INADDR_ANY) {
 		struct route sro;
 
-		sro.ro_rt = NULL;
+		bzero(&sro, sizeof(sro));
 		ia = (struct in_ifaddr *)0;
 		/*
 		 * If route is known our src addr is taken from the i/f,
@@ -589,7 +589,6 @@ in_pcbconnect_setup(inp, nam, laddrp, lp
 		 */
 		if ((inp->inp_socket->so_options & SO_DONTROUTE) == 0) {
 			/* Find out route to destination */
-			bzero(&sro.ro_dst, sizeof(struct sockaddr_in));
 			sro.ro_dst.sa_family = AF_INET;
 			sro.ro_dst.sa_len = sizeof(struct sockaddr_in);
 			((struct sockaddr_in *)&sro.ro_dst)->sin_addr = faddr;
Index: ip_input.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_input.c,v
retrieving revision 1.258
diff -u -p -r1.258 ip_input.c
--- ip_input.c	20 Nov 2003 20:07:38 -0000	1.258
+++ ip_input.c	26 Nov 2003 15:47:10 -0000
@@ -1616,7 +1616,7 @@ ip_rtaddr(dst)
 	struct sockaddr_in *sin;
 	struct in_ifaddr *ifa;
 
-	sro.ro_rt = NULL;
+	bzero(&sro, sizeof(sro));
 	sin = (struct sockaddr_in *)&sro.ro_dst;
 	sin->sin_family = AF_INET;
 	sin->sin_len = sizeof(*sin);
@@ -1879,7 +1879,7 @@ ip_forward(struct mbuf *m, int srcrt, st
 		struct route ro;
 		struct rtentry *rt;
 
-		ro.ro_rt = NULL;
+		bzero(&ro, sizeof(ro));
 		sin = (struct sockaddr_in *)&ro.ro_dst;
 		sin->sin_family = AF_INET;
 		sin->sin_len = sizeof(*sin);
Index: tcp_subr.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/tcp_subr.c,v
retrieving revision 1.168
diff -u -p -r1.168 tcp_subr.c
--- tcp_subr.c	20 Nov 2003 20:07:38 -0000	1.168
+++ tcp_subr.c	26 Nov 2003 15:47:13 -0000
@@ -1409,7 +1409,7 @@ tcp_maxmtu(inc)
 
 	KASSERT(inc != NULL, ("tcp_maxmtu with NULL in_conninfo pointer"));
 
-	sro.ro_rt = NULL;
+	bzero(&sro, sizeof(sro));
 	if (inc->inc_faddr.s_addr != INADDR_ANY) {
 	        dst = (struct sockaddr_in *)&sro.ro_dst;
 		dst->sin_family = AF_INET;
@@ -1439,7 +1439,7 @@ tcp_maxmtu6(inc)
 
 	KASSERT(inc != NULL, ("tcp_maxmtu6 with NULL in_conninfo pointer"));
 
-	sro6.ro_rt = NULL;
+	bzero(&sro6, sizeof(sro6));
 	if (!IN6_IS_ADDR_UNSPECIFIED(&inc->inc6_faddr)) {
 		sro6.ro_dst.sin6_family = AF_INET6;
 		sro6.ro_dst.sin6_len = sizeof(struct sockaddr_in6);
